@echo off
rem ****************************************************** 
rem ** Set this variable to your Java 1.5 JDK (or higher) 
rem ** directory.
rem ******************************************************
set JAVA_HOME=C:\Programme\Java\jdk1.5.0_05

rem ****************************************************** 
rem ** If the project structure is kept, this must not
rem ** be changed. Note that the bin-directory contains
rem ** the class files.
rem ******************************************************
set LOCALCLASSPATH=
for %%i in ("..\..\lib\*.jar") do call "lcp.bat" %%i
set LOCALCLASSPATH=..\..\bin\;%LOCALCLASSPATH%


rem ****************************************************** 
rem ** Here it is specified, where the source-files are
rem ** located. Must not be changed, if project structure
rem ** is kept.
rem ******************************************************
set LOCALSOURCEPATH=..\..\robocup\src\main\java\;..\..\soccerscope\src\main\java\;

rem ****************************************************** 
rem ** Here it is specified, where the class-files should
rem ** be placed. Must not be changed, if project structure
rem ** is kept, but the bin-directory must exists!
rem ** If changed, the start-scripts need to be adopted!
rem ******************************************************
set TARGETPATH=..\..\bin\

rem ****************************************************** 
rem ** Add all packages, that should be compiled, here
rem ******************************************************
set COMPILEFILES=..\..\robocup\src\main\java\robocup\component\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\infotypes\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\math\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\util\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\actionfactories\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\coach\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\tactics\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\tactics\GoalkeeperState.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\filters\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\worldobjects\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\geometry\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\speechacts\coachlanguage\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\speechacts\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\actions\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\worldmodel\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\component\situations\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\connection\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\robocup\src\main\java\robocup\parser9\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\db\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\net\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\training\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\training\conditions\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\file\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\view\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\view\layer\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\util\geom\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\util\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\util\analyze\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\daistatistic\tools\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\daistatistic\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\daistatistic\charts\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\model\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\model\agentplan\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\dialog\*.java
set COMPILEFILES=%COMPILEFILES% ..\..\soccerscope\src\main\java\soccerscope\analyzer\*.java

rem ****************************************************** 
rem ** If you have less than 1GB ram, reduce the Xmx and 
rem ** Xms settings (heapsize). About 512MB Xms are 
rem ** recommended.
rem ******************************************************
%JAVA_HOME%\bin\javac -cp %LOCALCLASSPATH% -d %TARGETPATH% -sourcepath %LOCALSOURCEPATH% %COMPILEFILES%
