-- phpMyAdmin SQL Dump
-- version 2.8.0.3
-- http://www.phpmyadmin.net
-- 
-- Host: localhost
-- Generation Time: Jul 19, 2006 at 03:52 PM
-- Server version: 4.1.10
-- PHP Version: 4.4.2
-- 
-- Database: `robocup`
-- 
CREATE DATABASE robocup;
USE robocup;
-- --------------------------------------------------------

-- 
-- Table structure for table `client_scene`
-- 

DROP TABLE IF EXISTS `client_scene`;
CREATE TABLE `client_scene` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `game_id` int(11) unsigned NOT NULL default '0',
  `play_mode` int(11) NOT NULL default '0',
  `ball_pos_x` float NOT NULL default '0',
  `ball_pos_y` float NOT NULL default '0',
  `ball_vel_x` float NOT NULL default '0',
  `ball_vel_y` float NOT NULL default '0',
  `time` int(11) NOT NULL default '0',
  `ball_mode` int(11) NOT NULL default '0',
  `ball_bestPosX` float default '0',
  `ball_bestPosY` float default '0',
  `ball_accX` float default '0',
  `ball_accY` float default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `game`
-- 

DROP TABLE IF EXISTS `game`;
CREATE TABLE `game` (
  `id` bigint(11) unsigned NOT NULL auto_increment,
  `team_left` varchar(16) default NULL,
  `team_right` varchar(16) default NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `score_left` smallint(5) unsigned default '0',
  `score_right` smallint(5) unsigned default '0',
  `scene_number` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`id`)
) TYPE=InnoDB;

-- --------------------------------------------------------

-- 
-- Table structure for table `player`
-- 

DROP TABLE IF EXISTS `player`;
CREATE TABLE `player` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `scene_id` int(11) unsigned NOT NULL default '0',
  `unum` tinyint(4) NOT NULL default '0',
  `pos_x` float NOT NULL default '0',
  `pos_y` float NOT NULL default '0',
  `vel_x` float NOT NULL default '0',
  `vel_y` float NOT NULL default '0',
  `acc_x` float NOT NULL default '0',
  `acc_y` float NOT NULL default '0',
  `side` int(11) NOT NULL default '0',
  `stamina` int(11) NOT NULL default '0',
  `angle` float NOT NULL default '0',
  `angle_neck` int(11) NOT NULL default '0',
  `angle_visible` int(11) NOT NULL default '0',
  `view_quality` int(11) NOT NULL default '0',
  `say_message` text NOT NULL,
  `catch_dir` float NOT NULL default '0',
  `offside` tinyint(1) NOT NULL default '0',
  `mode` int(11) NOT NULL default '0',
  `type` int(11) NOT NULL default '0',
  `player_type` int(11) NOT NULL default '0',
  `interception_time` int(11) NOT NULL default '0',
  `role_number` int(11) NOT NULL default '-1',
  `kick_count` int(11) NOT NULL default '0',
  `dash_count` int(11) NOT NULL default '0',
  `turn_count` int(11) NOT NULL default '0',
  `say_count` int(11) NOT NULL default '0',
  `turn_neck_count` int(11) NOT NULL default '0',
  `catch_count` int(11) NOT NULL default '0',
  `move_count` int(11) NOT NULL default '0',
  `change_view_count` int(11) NOT NULL default '0',
  `hear_message` text NOT NULL,
  `state` tinytext NOT NULL,
  `reliable` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `player_world_model`
-- 

DROP TABLE IF EXISTS `player_world_model`;
CREATE TABLE `player_world_model` (
  `id` int(11) NOT NULL auto_increment,
  `player_id` int(11) NOT NULL default '0',
  `positionX` double NOT NULL default '0' COMMENT 'Attribute von SimplePlayer',
  `positionY` double NOT NULL default '0',
  `positionIsReliable` tinyint(1) NOT NULL default '0',
  `isGoalie` tinyint(1) NOT NULL default '0',
  `simpleBody` double NOT NULL default '0',
  `speedX` double NOT NULL default '0',
  `speedY` double NOT NULL default '0',
  `ballInterceptionTime` int(11) NOT NULL default '0',
  `stamina` int(11) NOT NULL default '0',
  `playerType` int(11) NOT NULL default '0',
  `lastState` int(11) NOT NULL default '0',
  `roleNumber` int(11) NOT NULL default '0',
  `bestPosX` float default NULL,
  `bestPosY` float default NULL,
  `neckAngle` double NOT NULL default '0' COMMENT 'Attribute von PlayerWorldModel',
  `bodyAngle` double NOT NULL default '0',
  `ballPositionX` double NOT NULL default '0',
  `ballPositionY` double NOT NULL default '0',
  `ballSpeedX` double NOT NULL default '0',
  `ballSpeedY` double NOT NULL default '0',
  `ballInterceptX` double NOT NULL default '0',
  `ballInterceptY` double NOT NULL default '0',
  `oppNum` int(11) NOT NULL default '0',
  `markAreaX` double NOT NULL default '0',
  `markAreaY` double NOT NULL default '0',
  `markAreaRad` double NOT NULL default '0',
  `shouldMark` tinyint(1) NOT NULL default '0',
  `oppInterceptX` double NOT NULL default '0',
  `oppInterceptY` double NOT NULL default '0',
  `offsideY` double NOT NULL default '0',
  `doneAPass` tinyint(1) NOT NULL default '0',
  `passToPlayer` double NOT NULL default '0',
  `holes` int(11) NOT NULL default '0',
  `based_on_vi` tinyint(1) NOT NULL default '0',
  `stateInfos` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `simple_player`
-- 

DROP TABLE IF EXISTS `simple_player`;
CREATE TABLE `simple_player` (
  `id` int(11) NOT NULL auto_increment,
  `pwm_id` int(11) NOT NULL default '0',
  `type` enum('team_mate','opponent','next_team_mate','next_opponent') NOT NULL default 'team_mate',
  `positionX` double NOT NULL default '0',
  `positionY` double NOT NULL default '0',
  `positionIsReliable` tinyint(1) NOT NULL default '0',
  `isGoalie` tinyint(1) NOT NULL default '0',
  `simpleBody` double NOT NULL default '0',
  `speedX` double NOT NULL default '0',
  `speedY` double NOT NULL default '0',
  `ballInterceptionTime` int(11) NOT NULL default '0',
  `stamina` int(11) NOT NULL default '0',
  `playerType` int(11) NOT NULL default '0',
  `lastState` int(11) NOT NULL default '0',
  `roleNumber` int(11) NOT NULL default '0',
  `bestPosX` float default NULL,
  `bestPosY` float default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `team`
-- 

DROP TABLE IF EXISTS `team`;
CREATE TABLE `team` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `scene_id` int(11) unsigned NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `score` int(11) NOT NULL default '0',
  `offside_line` float NOT NULL default '0',
  `offside` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
