/*LICENSE_BEGIN
 * ******************************************************************
 * Copyright 2006 by the Dainamite Robocup-Team at the
 * DAI-Labor, TU-Berlin (www.dai-labor.de)
 * 
 * Members of Dainamite are:
 * Holger Endert
 * Robert Wetzker
 * Thomas Karbe
 * Axel Heßler
 * Philippe Bütter
 * Felix Brossmann
 * 
 * Licensed under the GNU GPL (General Public License) Free Software 
 * License, Version 2. You may use this file only in compliance with 
 * the License. You may obtain a copy of the License at:
 * 
 * http://www.fsf.org/licensing/licenses/gpl.txt
 * ******************************************************************
LICENSE_END*/
package robocup.component.actionfactories;

import robocup.component.WorldModel;
import robocup.component.actions.SayAction;
import robocup.component.speechacts.MessageFactory;

/**
 * A factory for creating say-actions. This class should be extended such 
 * that each state produces say-actions based on an own logic.
 */
public class SayActionFactory {

	/**
	 * determines the say action based on the (mainly) state.
	 * @param world -
	 *            the world
	 * 
	 * @return the say action
	 */
	public static SayAction getAction(WorldModel world) {

		MessageFactory mf = world.getMessageFactory();
		SayAction say = new SayAction(mf.encodePlayerPositionAndStamina(world
				.getSelfRef()));
		return say;
	}

}
