/*LICENSE_BEGIN
 * ******************************************************************
 * Copyright 2006 by the Dainamite Robocup-Team at the
 * DAI-Labor, TU-Berlin (www.dai-labor.de)
 * 
 * Members of Dainamite are:
 * Holger Endert
 * Robert Wetzker
 * Thomas Karbe
 * Axel Heßler
 * Philippe Bütter
 * Felix Brossmann
 * 
 * Licensed under the GNU GPL (General Public License) Free Software 
 * License, Version 2. You may use this file only in compliance with 
 * the License. You may obtain a copy of the License at:
 * 
 * http://www.fsf.org/licensing/licenses/gpl.txt
 * ******************************************************************
LICENSE_END*/
package robocup.component.actions;

/**
 * A sense body action. This will result in a new SenseBody-Information in the 
 * next cycle. Since per default, such an info is received every cycle, this
 * action is not used anymore.
 */
public class SenseBodyAction extends Action {

	/**
	 * Constructs a new SenseBodyAction.
	 */
	public SenseBodyAction() {
	}

	/**
	 * Returns the actions string representation:
	 * @return 
	 * (sense_body)<br><br>
	 */
	@Override
	public String toString() {
		return "(sense_body)";
	}

	/**
	 * @return retrieves the action-type SENSE_BODY.
	 */
	@Override
	public TYPE getType() {
		return Action.TYPE.SENSE_BODY;
	}
}
