/*LICENSE_BEGIN
 * ******************************************************************
 * Copyright 2006 by the Dainamite Robocup-Team at the
 * DAI-Labor, TU-Berlin (www.dai-labor.de)
 * 
 * Members of Dainamite are:
 * Holger Endert
 * Robert Wetzker
 * Thomas Karbe
 * Axel Heßler
 * Philippe Bütter
 * Felix Brossmann
 * 
 * Licensed under the GNU GPL (General Public License) Free Software 
 * License, Version 2. You may use this file only in compliance with 
 * the License. You may obtain a copy of the License at:
 * 
 * http://www.fsf.org/licensing/licenses/gpl.txt
 * ******************************************************************
LICENSE_END*/
package robocup.component.infotypes;

/**
 * This class refers to a seen flag by a player agent, i.e. the info that
 * is forwarded from the parser.
 */
public class FlagInfo extends VisualObjectInfo {
	/**
	 * Default constructor for a flag - this is a marker on the field, which is
	 * perceived to estimate the own position
	 * 
	 * @param cycle
	 *            Cycle of the flag
	 * @param iId
	 *            Id of the flag
	 * @param iDistance
	 *            Distance to the flag
	 * @param iDirection
	 *            Direction of the flag
	 */
	public FlagInfo(int cycle, int iId, double iDistance, double iDirection) {
		super(cycle, iId, iDistance, iDirection);
	}
	
	
	/**
	 * Returns the debug-String of the Object
	 * 
	 * @return String representation of the Object
	 * @see robocup.component.infotypes.Infos#print()
	 */
	@Override
	public String toString() {
		return ("Seen: " + getId() + ", " + this.distance + ", " + this.direction);
	}
}