/*LICENSE_BEGIN
 * ******************************************************************
 * Copyright 2006 by the Dainamite Robocup-Team at the
 * DAI-Labor, TU-Berlin (www.dai-labor.de)
 * 
 * Members of Dainamite are:
 * Holger Endert
 * Robert Wetzker
 * Thomas Karbe
 * Axel Heßler
 * Philippe Bütter
 * Felix Brossmann
 * 
 * Licensed under the GNU GPL (General Public License) Free Software 
 * License, Version 2. You may use this file only in compliance with 
 * the License. You may obtain a copy of the License at:
 * 
 * http://www.fsf.org/licensing/licenses/gpl.txt
 * ******************************************************************
LICENSE_END*/
package robocup.component.infotypes;

import robocup.component.SConf;

/**
 * This class holds a server-configuration, which is received after 
 * initialization. This is already stored within the contained SConf-object.
 */
public class ServerParamInfo extends Info {

	/**
	 * The server-configuration for the current game.
	 */
	private SConf sConf;

	/**
	 * Constructor needs no additional data, holds an object of the type SConf,
	 * which stores all necessary parameters
	 */
	public ServerParamInfo() {
		super(-1);
		this.infoType = Info.TYPE_SPARAM;
	}

	/**
	 * @return Returns the server-configuration.
	 */
	public SConf getSConf() {
		return this.sConf;
	}

	/**
	 * Sets a new server-configuration.
	 * @param conf
	 */
	public void setSConf(SConf conf) {
		this.sConf = conf;
	}

}
