/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.model;

import java.io.Serializable;

import soccerscope.util.Time;

public abstract class Scene implements Comparable, Serializable {

    /**
     * id for serialization. 
     */
    private static final long serialVersionUID = 3256726186435426101L;

	public int time;

	public PlayMode pmode;

	public Ball ball;

	public Team left;

	public Team right;

	public Scene() {
		this.time = Time.MAX_TIME;
		this.pmode = new PlayMode();
		this.ball = new Ball();
		this.left = new Team(Team.LEFT_SIDE);
		this.right = new Team(Team.RIGHT_SIDE);
	}

	public int compareTo(Object obj) {
		return this.time - ((ClientScene) obj).time;
	}
}
/*
 * $Log: Scene.java,v $
 * Revision 1.1.28.5  2006/11/23 09:41:02  endert
 * Added License Note at top of each *.java file.
 *
 * Revision 1.1.28.4  2006/11/13 16:50:17  endert
 * Removed CVS-Logs and author tags
 *
 * Revision 1.1.28.3  2006/10/25 14:33:34  endert
 * Latest SoccerScope Version plus Database ability
 *
 * Revision 1.1.14.1  2006/07/08 07:40:02  benjaboe
 * Speichern und Laden scheint zu funktionieren
 *
 * Revision 1.1  2006/03/13 07:37:44  axle
 * moved from ROOT/src for Maven 2 Buildsystem and Team/Soccerscope separation
 *
 * Revision 1.4  2006/03/07 12:46:01  endert
 * Merge after refactoring:
 *  - New State-Interface: One Method for each action type
 *  - Action Bean removed - ActionFactorys for helper methods, States calculate
 *    main-Action themselves
 *  - formatted code
 *  - added State-List in Monitor (Context-Menu of Player)
 *  - other smaller stuff
 *
 * Revision 1.3.2.1  2006/02/25 22:07:23  wetzker
 * formated
 *
 * Revision 1.3  2006/02/22 16:04:43  endert
 * This is done:
 * - Rebound SoccerScope to Agents (can be added or removed in config-file)
 * - Situations now all extend abstract class Situation
 * - Refactorings: ActionBean _ removed from Attributes
 * - SoccerScope will automatically connect to host given in Start-Call
 * - Trainer uses the same host as soccerscope
 * - Removed unused stuff (old confs, bat, etc.)
 * - Code formatted (good luck when merging)
 * - organized imports
 * - all that i forgot to mention here
 * Revision 1.2 2005/10/25 20:51:38 endert Added Training-Editor to
 * SoccerScope, restructuring in some old classes and some experimental stuff
 * (goals, commitments, mental model)
 * 
 * Revision 1.1.14.1 2005/10/10 11:05:13 endert New Training-Scenario Editor!
 * There exists a dialog, which opens on middle-mouse click on the field. From
 * here, the Trainings-Scenario may be specified in a more comfortable manner.
 * The Trainings-Scenario is also visualized on the Field - using the
 * TrainingModelLayer. The TrainingModel itself contains all data specified in
 * the scenario, and therefor can be serialized to HDD, using an XML-Stream
 * generator (XStream). The Scenario editor is still under development.
 * 
 * Revision 1.1 2005/04/20 10:39:03 endert Fresh Team Repository installation
 * from /home/e/endert/Robocup to here.
 * 
 * Revision 1.4 2005/03/13 14:33:03 haeder * some modifications to reduce the
 * number of warnings ;-)
 * 
 * Revision 1.3 2005/02/06 07:17:26 maketi Added soccerscope with connection to
 * our world model
 * 
 * Revision 1.7 2002/10/10 09:43:33 koji ͥΰη׻β
 * (Direction-Distance Table)
 * 
 * Revision 1.6 2002/10/04 10:39:06 koji
 * Tuple,Point,VectorΥѥåѹGeometry,Circle,Line,Rectangleɲ
 * 
 * Revision 1.5 2002/09/12 17:07:03 koji HeteroParamäѹHetro->Hetero
 * 
 * Revision 1.4 2002/09/05 10:20:19 taku-ako إƥץ쥤䡼б
 * 
 * Revision 1.3 2002/09/05 09:46:33 koji ٥ȥǽɲ
 * 
 * Revision 1.2 2002/09/02 07:05:28 taku-ako GeometryϢΥ饤֥
 * 
 * Revision 1.1.1.1 2002/03/01 14:12:54 koji CVS
 * 
 */
