/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.model;

import java.io.Serializable;

import soccerscope.util.Color2;
import soccerscope.util.geom.Point2f;
import soccerscope.util.geom.Vector2f;

public class SoccerObject implements Serializable{

    /**
     * id for serialization. 
     */
    private static final long serialVersionUID = 3256726186435426101L;


	public Point2f pos; // position
  public Point2f bestPos; // position

	public Vector2f vel; // velocity

	public Vector2f acc; // acceleration<s

	public SoccerObject() {
		this.pos = new Point2f();
		this.vel = new Vector2f();
		this.acc = new Vector2f();
	}

	public void setPosition(Point2f pos) {
		if (pos == null)
			return;
		this.pos.set(pos);
	}

	public void setSpeed(Point2f spd) {
		if (spd == null)
			return;
		this.vel.set(spd);
	}

	public float getSize() {
		return 0.15f;
	}

	public java.awt.Color getColor() {
		return Color2.white;
	}
  
}
