/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.util.geom;

public class Line2f {

	public final static float EPS = 1.0e-3f;

	/* Ax + By + C = 0 */
	public float A;

	/**
	 * < ľη
	 */
	public float B;

	/**
	 * < ľη
	 */
	public float C;

	/** < ľη */

	// public static void main(String args[]) {
	// Point2f o = new Point2f();
	// Point2f a = new Point2f(1,1);
	// Point2f b = new Point2f(1,0);
	// Point2f c = new Point2f(0,1);
	// Point2f d = new Point2f(-1,1);
	// Line2f l1 = new Line2f(o, a);
	// Line2f l2 = new Line2f(o, d);
	// Line2f l3 = new Line2f(o, b);
	// Line2f l4 = new Line2f(o, c);
	// Line2f l5 = new Line2f(o, 45);
	// Line2f l6 = new Line2f(o, -45);
	// System.out.println(l1);
	// System.out.println(l2);
	// System.out.println(l1.intersection(l2));
	// System.out.println(l1.projectpoint(b));
	// System.out.println(l1.projectpoint(c));
	// System.out.println(l3);
	// System.out.println(l4);
	// System.out.println(l5);
	// System.out.println(l6);
	// }
	/**
	 * 󥹥ȥ饯
	 */
	public Line2f() {
		this.A = 0;
		this.B = 0;
		this.C = 0;
	}

	/**
	 * 󥹥ȥ饯 A,B,Cľ
	 * 
	 * @param A
	 *            ľη
	 * @param B
	 *            ľη
	 * @param C
	 *            ľη
	 */
	public Line2f(float A, float B, float C) {
		this.A = A;
		this.B = B;
		this.C = C;
	}

	/**
	 * 󥹥ȥ饯 p1,p2̤ľ
	 * 
	 * @param p1
	 *            ľ
	 * @param p2
	 *            ľ
	 */
	public Line2f(Point2f p1, Point2f p2) {
		this.A = p1.y - p2.y;
		this.B = p2.x - p1.x;
		this.C = -this.B * p1.y - this.A * p1.x;
	}

	/**
	 * 󥹥ȥ饯 p̤,angle٤ηľ
	 * angle+/-90ʤ
	 * 
	 * @param p
	 *            ľ
	 * @param angle
	 *             ()
	 */
	public Line2f(Point2f p, float angle) {
		float m = (float) Math.tan(Math.toRadians(angle));
		this.A = -m;
		this.B = 1;
		this.C = -p.y + m * p.x;
	}

	/**
	 * ԡ󥹥ȥ饯
	 * 
	 * @param l
	 *            ԡ
	 */
	public Line2f(Line2f l) {
		this.A = l.A;
		this.B = l.B;
		this.C = l.C;
	}

	/**
	 * yбx֤
	 * 
	 * @param y
	 *            y
	 * @return yˤäƷޤx
	 */
	public float getX(float y) {
		return -this.B / this.A * y - this.C / this.A;
	}

	/**
	 * xбy֤
	 * 
	 * @param x
	 *            
	 * @return xˤäƷޤy
	 */
	public float getY(float x) {
		return -this.A / this.B * x - this.C / this.B;
	}

	/**
	 * xҤ֤
	 * 
	 * @return x
	 */
	public float xIntercept() {
		return -this.C / this.A;
	}

	/**
	 * yҤ֤
	 * 
	 * @return y
	 */
	public float yIntercept() {
		return -this.C / this.B;
	}

	/**
	 * ٤֤
	 * 
	 * @return γ()
	 */
	public float angle() {
		return (float) Math.toDegrees(Math.atan(-this.A / this.B));
	}

	/**
	 * ľlȤγ٤֤
	 * 
	 * @param l
	 *            ľ
	 * @return ľlȤγ
	 */
	public float angle(Line2f l) {
		return (float) Math.toDegrees(Math.atan((this.A * l.B - l.A * this.B)
				/ (this.A * l.A + this.B * l.B)));
	}

	/**
	 * pεΥ֤
	 * 
	 * @param p
	 *            
	 * @return pεΥ
	 */
	public float dist(Point2f p) {
		return (float) (Math.abs(this.A * p.x + this.B * p.y + this.C) / Math
				.sqrt(this.A * this.A + this.B * this.B));
	}

	/**
	 * ľˤ뤫ɤȽꤹ롣ľˤ硢true֤
	 * 
	 * @param p
	 *            
	 * @return ľˤ뤫ɤ
	 */
	public boolean online(Point2f p) {
		return Math.abs(this.A * p.x + this.B * p.y + this.C) < EPS;
	}

	/**
	 * p(򲼤Ȥθ)֤
	 * 
	 * @param p
	 *            
	 * @return 
	 */
	public Point2f projectpoint(Point2f p) {
		return intersection(perpendicular(p));
	}

	/**
	 * ľlȸ뤫ɤ֤
	 * 
	 * @param l
	 *            ľ
	 * @return ľlȸ뤫ɤ
	 */
	public boolean intersect(Line2f l) {
		float slope = this.A * l.B - l.A * this.B;
		return slope != 0;
	}

	/**
	 * ľlȤθ֤
	 * 
	 * @param l
	 *            ľ
	 * @return 
	 */
	public Point2f intersection(Line2f l) {
		float slope = this.A * l.B - l.A * this.B;
		// ʿԤǤ
		if (slope == 0) {
			// פƤ
			if (this.B * l.C - l.B * this.C == 0
					&& l.A * this.C - this.A * l.C == 0) {
				return randomSample();
			} else {
				return new Point2f();
			}
		}

		return new Point2f((this.B * l.C - l.B * this.C) / slope,
				(l.A * this.C - this.A * l.C) / slope);
	}

	/**
	 * p̤ľ֤
	 * 
	 * @param p
	 *            
	 * @return p̤ľ
	 */
	public Line2f perpendicular(Point2f p) {
		return new Line2f(this.B, -this.A, this.A * p.y - this.B * p.x);
	}

	/**
	 * ľΥ(0<=x<1)֤
	 */
	public Point2f randomSample() {
		if (this.A == 0)
			return new Point2f((float) Math.random(), -this.C / this.B);
		else if (this.B == 0)
			return new Point2f(-this.C / this.A, (float) Math.random());
		float random_x = (float) Math.random();
		return new Point2f(random_x, getY(random_x));
	}

	/**
	 * ʸɽ֤
	 * 
	 * @return ʸ
	 */
	@Override
	public String toString() {
		if (this.A == 0)
			return "y = " + Float.toString(-this.C / this.B);
		else if (this.B == 0)
			return "x = " + Float.toString(-this.C / this.A);
		return this.A + "x + " + this.B + "y + " + this.C + " = 0";
	}
}
