/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.util.geom;

public class Rectangle2f {

	public Point2f topleft;

	/**
	 * < κɸ
	 */
	public float width;

	/**
	 * < 
	 */
	public float height;

	/** < ⤵ */

	/**
	 * 󥹥ȥ饯
	 */
	public Rectangle2f() {
		this.topleft = new Point2f();
		this.width = 0;
		this.height = 0;
	}

	/**
	 * 󥹥ȥ饯
	 * 
	 * @param p
	 *            κɸ
	 * @param width
	 *            
	 * @param height
	 *            ⤵
	 */
	public Rectangle2f(Point2f p, float width, float height) {
		this.topleft = new Point2f(p);
		this.width = width;
		this.height = height;
	}

	/**
	 * 󥹥ȥ饯
	 * 
	 * @param topleftx
	 *            κxɸ
	 * @param toplefty
	 *            κyɸ
	 * @param width
	 *            
	 * @param height
	 *            ⤵
	 */
	public Rectangle2f(float topleftx, float toplefty, float width, float height) {
		this.topleft = new Point2f(topleftx, toplefty);
		this.width = width;
		this.height = height;
	}

	/**
	 * ԡ󥹥ȥ饯
	 * 
	 * @param r
	 *            
	 */
	public Rectangle2f(Rectangle2f r) {
		this.topleft = new Point2f(r.topleft);
		this.width = r.width;
		this.height = r.height;
	}

	/**
	 * ꤹ
	 * 
	 * @param width
	 *            
	 * @param height
	 *            ⤵
	 */
	public void setWidth(float width, float height) {
		this.width = width;
		this.height = height;
	}

	/**
	 * ꤹ
	 * 
	 * @param p
	 *            κɸ
	 * @param width
	 *            
	 * @param height
	 *            ⤵
	 */
	public void set(Point2f p, float width, float height) {
		this.topleft.set(p);
		this.width = width;
		this.height = height;
	}

	/**
	 * ꤹ
	 * 
	 * @param topleftx
	 *            κxɸ
	 * @param toplefty
	 *            κyɸ
	 * @param width
	 *            
	 * @param height
	 *            ⤵
	 */
	public void set(float topleftx, float toplefty, float width, float height) {
		this.topleft.x = topleftx;
		this.topleft.y = toplefty;
		this.width = width;
		this.height = height;
	}

	/**
	 * rꤹ
	 * 
	 * @param r
	 *            
	 */
	public void set(Rectangle2f r) {
		this.topleft.set(r.topleft);
		this.width = r.width;
		this.height = r.height;
	}

	/**
	 * (x,y)ޤफɤȽꤹ롣ޤ硢true֤
	 * 
	 * @param x
	 *            xɸ
	 * @param y
	 *            yɸ
	 * @return (x,y)ޤफɤ
	 */
	public boolean contains(float x, float y) {
		return (this.topleft.x <= x && x <= this.topleft.x + this.width)
				&& (this.topleft.y <= y && y <= this.topleft.y + this.height);
	}

	/**
	 * pޤफɤȽꤹ롣ޤ硢true֤
	 * 
	 * @param p
	 *            Ǥդ
	 * @return (x,y)ޤफɤ
	 */
	public boolean contains(Point2f p) {
		return contains(p.x, p.y);
	}

	/**
	 * rޤफɤȽꤹ롣ޤ硢true֤
	 * 
	 * @param r
	 *            
	 * @return rޤफɤ
	 */
	public boolean contains(Rectangle2f r) {
		return contains(r.topleft.x, r.topleft.y)
				&& contains(r.topleft.x, r.topleft.y + this.height)
				&& contains(r.topleft.x + this.width, r.topleft.y)
				&& contains(r.topleft.x + this.width, r.topleft.y + this.height);
	}

	/*
	 * public Point2f topleft() { return Point2f(topleft); }
	 */

	/**
	 * ֤
	 * 
	 * @return 
	 */
	public Point2f topright() {
		return new Point2f(this.topleft.x + this.width, this.topleft.y);
	}

	/**
	 * ֤
	 * 
	 * @return 
	 */
	public Point2f bottomleft() {
		return new Point2f(this.topleft.x, this.topleft.y + this.height);
	}

	/**
	 * ֤
	 * 
	 * @return 
	 */
	public Point2f bottomright() {
		return new Point2f(this.topleft.x + this.width, this.topleft.y
				+ this.height);
	}

	/**
	 * ʸɽ֤
	 * 
	 * @return ʸ
	 */
	@Override
	public String toString() {
		return this.topleft + " " + this.width + " " + this.height;
	}
}
