/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.util.geom;

import java.awt.geom.Point2D;
import java.io.Serializable;

/**
 * 2ĤͤȤɽ饹
 */
public class Tuple2f extends Point2D implements Serializable {
	/**
	 * Tuple2fxʬ
	 */
	public float x;

	/**
	 * Tuple2fyʬ
	 */
	public float y;

	/**
	 * x=0, y=0ǿTuple2f.
	 */
	public Tuple2f() {
		this.x = 0.0f;
		this.y = 0.0f;
	}

	/**
	 * x,yͤꤷTuple2f.
	 * 
	 * @param x
	 *            x
	 * @param y
	 *            y
	 */
	public Tuple2f(float x, float y) {
		this.x = x;
		this.y = y;
	}

	/**
	 * ꤷTuple2f֥tƱͤTuple2f.
	 * 
	 * @param t
	 *            Tuple2f֥
	 */
	public Tuple2f(Tuple2f t) {
		this.x = t.x;
		this.y = t.y;
	}

	/**
	 * Tuple2fx,yǤͤꤹ.
	 * 
	 * @param x
	 *            x
	 * @param y
	 *            y
	 */
	public void set(float x, float y) {
		this.x = x;
		this.y = y;
	}

	/**
	 * Tuple2fx,yǤͤꤹ.
	 * 
	 * @param x
	 *            x
	 * @param y
	 *            y
	 */
	@Override
  public void setLocation(double x, double y) {
		set((float) x, (float) y);
	}

	/**
	 * Tuple2fxǤͤꤹ.
	 * 
	 * @param x
	 *            x
	 */
	public void setX(float x) {
		this.x = x;
	}

	/**
	 * Tuple2fyǤͤꤹ.
	 * 
	 * @param y
	 *            y
	 */
	public void setY(float y) {
		this.y = y;
	}

	/**
	 * x,yǤͤ,ꤵ줿Tuple2f֥tx,yǤƱͤꤹ.
	 * 
	 * @param t
	 *            Tuple2f֥
	 */
	public void set(Tuple2f t) {
		this.x = t.x;
		this.y = t.y;
	}

	/**
	 * x,yǤͤꤷ1,2ܤ˳Ǽ.
	 * 
	 * @param t
	 *            float
	 */
	public void get(float t[]) {
		t[0] = this.x;
		t[1] = this.y;
	}

	/**
	 * xǤ֤.
	 * 
	 * @return x
	 */
	@Override
  public double getX() {
		return this.x;
	}

	/**
	 * yǤ֤.
	 * 
	 * @return y
	 */
	@Override
  public double getY() {
		return this.y;
	}

	/**
	 * Tuple2f,ꤷTuple2f֥tͤä.
	 * 
	 * @param t
	 *            Tuple2f֥
	 */
	public void add(Tuple2f t) {
		this.x += t.x;
		this.y += t.y;
	}

	/**
	 * Tuple2fͤ,ꤷ2ĤTuple2f֥t1,t2¤ꤹ.
	 * 
	 * @param t1
	 *            Tuple2f֥
	 * @param t2
	 *            Tuple2f֥
	 */
	public void add(Tuple2f t1, Tuple2f t2) {
		this.x = t1.x + t2.x;
		this.y = t1.y + t2.y;
	}

	/**
	 * Tuple2f,ꤷTuple2f֥tͤ.
	 * 
	 * @param t
	 *            Tuple2f֥
	 */
	public void sub(Tuple2f t) {
		this.x -= t.x;
		this.y -= t.y;
	}

	/**
	 * Tuple2fͤ,ꤷ2ĤTuple2f֥t1,t2κꤹ.
	 * 
	 * @param t1
	 *            Tuple2f֥
	 * @param t2
	 *            Tuple2f֥
	 */
	public void sub(Tuple2f t1, Tuple2f t2) {
		this.x = t1.x - t2.x;
		this.y = t1.y - t2.y;
	}

	/**
	 * Tuple2fͤž.
	 */
	public void negate() {
		this.x = -this.x;
		this.y = -this.y;
	}

	/**
	 * Tuple2fͤ,Tuple2f֥tžͤꤹ.
	 * 
	 * @param t
	 *            Tuple2f֥
	 */
	public void negate(Tuple2f t) {
		this.x = -t.x;
		this.y = -t.y;
	}

	/**
	 * Tuple2f֥ȤaǼ¿ܤ.
	 * 
	 * @param a
	 *            
	 */
	public void scale(float a) {
		this.x *= a;
		this.y *= a;
	}

	/**
	 * Tuple2fͤ,ꤷTuple2f֥taǼ¿ܤ̤ꤹ.
	 * 
	 * @param a
	 *            
	 * @param t
	 *            Tuple2f֥
	 */
	public void scale(float a, Tuple2f t) {
		this.x = a * t.x;
		this.y = a * t.y;
	}

	/**
	 * Tuple2f֥ȤaǼ¿ܤ,tä. (= a*this + t)
	 * 
	 * @param a
	 *            
	 * @param t
	 *            ûTuple2f֥
	 */
	public void scaleAdd(float a, Tuple2f t) {
		this.x = a * this.x + t.x;
		this.y = a * this.y + t.y;
	}

	/**
	 * Tuple2fͤ,Tuple2f֥t1aǼ¿ܤΤ,t2¤
	 * ꤹ. (= a*t1 + t2)
	 * 
	 * @param a
	 *            
	 * @param t1
	 *            ܤTuple2f֥
	 * @param t2
	 *            ûTuple2f֥
	 */
	public void scaleAdd(float a, Tuple2f t1, Tuple2f t2) {
		this.x = a * t1.x + t2.x;
		this.y = a * t1.y + t2.y;
	}

	/**
	 * Tuple2f֥tȤTuple2f֥ȤγǤͤ,֤.
	 * 
	 * @param t
	 *            оݤȤʤTuple2f֥
	 */
	public boolean equals(Tuple2f t) {
		return this.x == t.x && this.y == t.y;
	}

	/**
	 * ֥tTuple2f֥ȤǤ,ĤTuple2f֥ȤγǤ
	 * ͤ,֤.
	 * 
	 * @param o
	 *            оݤȤʤ륪֥
	 */
	@Override
  public boolean equals(Object o) {
		return (o instanceof Tuple2f) && equals((Tuple2f) o);
	}

	/**
	 * Tuple2f,Tuple2f֥tλԳΥѥ᡼epsilonʲ
	 * Ǥä,֤.ԳΥ=MAX[abs(x1-x2), abs(y1-y2)]
	 * 
	 * @param t
	 *            оݤȤʤTuple2f֥
	 * @param epsilon
	 *            
	 */
	public boolean epsilonEquals(Tuple2f t, float epsilon) {
		return (Math.abs(t.x - this.x) <= epsilon)
				&& (Math.abs(t.y - this.y) <= epsilon);
	}

	/**
	 * Tuple2fͤ,[min , max]ϰϤ˥פ.
	 * 
	 * @param min
	 *            
	 * @param max
	 *            
	 */
	public void clamp(float min, float max) {
		clampMin(min);
		clampMax(max);
	}

	/**
	 * Tuple2fͤ,[min , ]ϰϤ˥פ.
	 * 
	 * @param min
	 *            
	 */
	public void clampMin(float min) {
		if (this.x < min)
			this.x = min;
		if (this.y < min)
			this.y = min;
	}

	/**
	 * Tuple2fͤ,[- , max]ϰϤ˥פ.
	 * 
	 * @param max
	 *            
	 */
	public void clampMax(float max) {
		if (this.x > max)
			this.x = max;
		if (this.y > max)
			this.y = max;
	}

	/**
	 * Tuple2fxǤͤ,[min , max]ϰϤ˥פ.
	 * 
	 * @param min
	 *            
	 * @param max
	 *            
	 */
	public void clampX(float min, float max) {
		clampMinX(min);
		clampMaxX(max);
	}

	/**
	 * Tuple2fxǤͤ,[min , ]ϰϤ˥פ.
	 * 
	 * @param min
	 *            
	 */
	public void clampMinX(float min) {
		if (this.x < min)
			this.x = min;
	}

	/**
	 * Tuple2fxǤͤ,[- , max]ϰϤ˥פ.
	 * 
	 * @param max
	 *            
	 */
	public void clampMaxX(float max) {
		if (this.x > max)
			this.x = max;
	}

	/**
	 * Tuple2fyǤͤ,[min , max]ϰϤ˥פ.
	 * 
	 * @param min
	 *            
	 * @param max
	 *            
	 */
	public void clampY(float min, float max) {
		clampMinY(min);
		clampMaxY(max);
	}

	/**
	 * Tuple2fyǤͤ,[min , ]ϰϤ˥פ.
	 * 
	 * @param min
	 *            
	 */
	public void clampMinY(float min) {
		if (this.y < min)
			this.y = min;
	}

	/**
	 * Tuple2fyǤͤ,[- , max]ϰϤ˥פ.
	 * 
	 * @param max
	 *            
	 */
	public void clampMaxY(float max) {
		if (this.y > max)
			this.y = max;
	}

	/**
	 * Tuple2fγǤͤȤͤͤꤹ.
	 */
	public void absolute() {
		if (this.x < 0.0)
			this.x = -this.x;
		if (this.y < 0.0)
			this.y = -this.y;
	}

	/**
	 * Tuple2fʸɽ֤
	 */
	@Override
  public String toString() {
		return "(" + this.x + ", " + this.y + ")";
	}
}
