/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.util.geom;

import java.io.Serializable;

/**
 * 2Υ٥ȥ륯饹
 */
public class Vector2f extends Tuple2f implements Serializable{

    /**
     * id for serialization. 
     */
    private static final long serialVersionUID = 3256726186435426101L;

	/**
	 * x=0, y=0ǿVector2f.
	 */
	public Vector2f() {
		super();
	}

	/**
	 * x,yͤꤷVector2f.
	 * 
	 * @param x
	 *            x
	 * @param y
	 *            y
	 */
	public Vector2f(float x, float y) {
		super(x, y);
	}

	/**
	 * ꤷVector2f֥vƱͤVector2f.
	 * 
	 * @param v
	 *            Vector2f֥
	 */
	public Vector2f(Vector2f v) {
		super(v);
	}

	/**
	 * ꤷTuple2f֥tƱͤVecor2f.
	 * 
	 * @param t
	 *            Tuple2f֥
	 */
	public Vector2f(Tuple2f t) {
		super(t);
	}

	/**
	 * s,eȤ٥ȥ.
	 * 
	 * @param s
	 *            
	 * @param e
	 *            
	 */
	public Vector2f(Point2f s, Point2f e) {
		super(e.x - s.x, e.y - s.y);
	}

	/**
	 * Vector2fvȤѤ֤.
	 * 
	 * @param v
	 *            Vector2f֥
	 * @return 
	 */
	public float dot(Vector2f v) {
		return this.x * v.x + this.y * v.y;
	}

	/**
	 * Υ٥ȥ礭֤.
	 * 
	 * @return 礭
	 */
	public float r() {
		return (float) Math.sqrt(this.x * this.x + this.y * this.y);
	}

	/**
	 * Υ٥ȥ礭֤.
	 * 
	 * @return 礭
	 */
	public float length() {
		return (float) Math.sqrt(this.x * this.x + this.y * this.y);
	}

	/**
	 * Υ٥ȥ礭ʿ֤.
	 * 
	 * @return 礭ʿ
	 */
	public float lengthSquared() {
		return this.x * this.x + this.y * this.y;
	}

	/**
	 * Υ٥ȥΤ֤.
	 * 
	 * @return ٥ȥ
	 */
	public Vector2f normalize() {
		float d = r();
		return new Vector2f(this.x / d, this.y / d);
	}

	/**
	 * Υ٥ȥγ٤֤.
	 * 
	 * @return  ()
	 */
	public float th() {
		return (float) Math.toDegrees(Math.atan2(this.y, this.x));
	}

	/**
	 * Υ٥ȥȥ٥ȥvȤγ٤֤
	 * 
	 * @param v
	 *            Vector2f֥
	 * @return  ()
	 */
	public float angle(Vector2f v) {
		return (float) Math.abs(Math.toDegrees(Math.atan2(this.x * v.y - this.y * v.x,
				dot(v))));
	}

	/**
	 * Υ٥ȥthٲž٥ȥ֤.
	 * 
	 * @param th
	 *            ž
	 * @return ž٥ȥ
	 */
	public Vector2f rotate(float th) {
		double d = Math.toRadians(th);
		return new Vector2f((float) (this.x * Math.cos(d) - this.y * Math.sin(d)),
				(float) (this.x * Math.sin(d) + this.y * Math.cos(d)));
	}

	/**
	 * ˺ɸʸ֤
	 * 
	 * @return ˺ɸʸ
	 */
	public String toPolar() {
		return "(" + r() + ", " + th() + ")";
	}

	/**
	 * ˺ɸ٥ȥ.
	 * 
	 * @param r
	 *            ˺ɸȾʬ
	 * @param th
	 *            ˺ɸγʬ
	 * @return Vector2f֥
	 */
	public static Vector2f polar2vector(float r, float th) {
		double d = Math.toRadians(th);
		return new Vector2f((float) (r * Math.cos(d)),
				(float) (r * Math.sin(d)));
	}
}
