/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.view;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTable;

import soccerscope.model.HeteroParam;
import soccerscope.util.GameAnalyzer;

public class StatisticsWindow extends JFrame {

	private static final long serialVersionUID = 3257007648594802487L;

	public final static String title = "statistics";

	// private ClientScene clientScene;
	// private JCheckBox chr, chl;

	public StatisticsWindow() {
		super(title);

		// ѿν
		// clientScene = ClientScene.createScene();

		JTabbedPane tabbedPane = new JTabbedPane();
		getContentPane().add(tabbedPane);

		/* Statistics */
		JPanel jp1 = new JPanel();
		jp1.setLayout(new BorderLayout());

		JTable table = new JTable(GameAnalyzer.getTableModel());
		jp1.add(table.getTableHeader(), BorderLayout.NORTH);
		jp1.add(table, BorderLayout.CENTER);

		tabbedPane.add("total statistics", jp1);

		/* Left Team Statistics */
		JPanel jp2 = new JPanel();
		jp2.setLayout(new BorderLayout());

		JTable ltable = new JTable(GameAnalyzer.getLeftTableModel());
		jp2.add(ltable.getTableHeader(), BorderLayout.NORTH);
		jp2.add(ltable, BorderLayout.CENTER);

		tabbedPane.add("left statistics", jp2);

		/* Right Team Statistics */
		JPanel jp3 = new JPanel();
		jp3.setLayout(new BorderLayout());

		JTable rtable = new JTable(GameAnalyzer.getRightTableModel());
		jp3.add(rtable.getTableHeader(), BorderLayout.NORTH);
		jp3.add(rtable, BorderLayout.CENTER);

		tabbedPane.add("right statistics", jp3);

		/* Hetero Parameter */
		JPanel jp4 = new JPanel();
		jp4.setLayout(new BorderLayout());

		JTable htable = new JTable(HeteroParam.getTableModel());
		jp4.add(htable.getTableHeader(), BorderLayout.NORTH);
		jp4.add(htable, BorderLayout.CENTER);

		tabbedPane.add("hetero", jp4);

		/* Chart */
		// String cat[] = {"1-1000", "1001-2000", "2001-3000", "3001-4000",
		// "4001-5000", "5001-6000", "Total"};
		// String ser[] = {"Left Team", "Right Team"};
		/*
		 * double data[][] = new double[2][7]; for (int i = 0; i < 6; i++) {
		 * data[0][i] = Double.parseDouble(ltable.getValueAt(11, i +
		 * 1).toString()); data[1][i] = Double.parseDouble(rtable.getValueAt(11,
		 * i + 1).toString()); } data[0][6] =
		 * Double.parseDouble(table.getValueAt(11, 1).toString()); data[1][6] =
		 * Double.parseDouble(table.getValueAt(11, 2).toString());
		 */
		// DefaultCategoryDataset dcd = new DefaultCategoryDataset(data);
		org.jfree.data.category.DefaultCategoryDataset dcd = new org.jfree.data.category.DefaultCategoryDataset();
		Number num;

		for (int i = 0; i < 6; i++) {
			// dcd.addValue(Double.parseDouble(ltable.getValueAt(11, i +
			// 1).toString()),0,i);
			num = Double.parseDouble(ltable.getValueAt(11, i + 1).toString());
			dcd.setValue(num, 0, i);

			// data[1][i] = Double.parseDouble(rtable.getValueAt(11, i +
			// 1).toString());
			num = Double.parseDouble(rtable.getValueAt(11, i + 1).toString());
			dcd.setValue(num, 1, i);

		}
		// data[0][6] = Double.parseDouble(table.getValueAt(11, 1).toString());
		num = Double.parseDouble(table.getValueAt(11, 1).toString());
		dcd.setValue(num, 0, 6);
		// data[1][6] = Double.parseDouble(table.getValueAt(11, 2).toString());
		num = Double.parseDouble(table.getValueAt(11, 2).toString());
		dcd.setValue(num, 1, 6);

		// dcd.setCategories(cat);
		// dcd.setSeriesNames(ser);
		/*
		 * JFreeChart jfc = ChartFactory.createLineChart("Statistics Chart",
		 * "Time", "BallPossession [%]", dcd,
		 * PlotOrientation.VERTICAL,true,true,true); ChartPanel cp = new
		 * ChartPanel(jfc);
		 * 
		 * tabbedPane.add("chart", cp);
		 */
		/* PassChain Table */
		JPanel jp6 = new JPanel();
		jp6.setLayout(new BorderLayout());

		JTable pstable = new JTable(GameAnalyzer.getAnalyzer("Pass Chain")
				.getTableModel());
		jp6.add(pstable.getTableHeader(), BorderLayout.NORTH);
		jp6.add(pstable, BorderLayout.CENTER);

		tabbedPane.add("pass chain", jp6);

		pack();

	}

}
/**
 * $Log: StatisticsWindow.java,v $
 * Revision 1.1.28.4  2006/11/23 09:41:04  endert
 * Added License Note at top of each *.java file.
 *
 * Revision 1.1.28.3  2006/11/13 16:50:18  endert
 * Removed CVS-Logs and author tags
 *
 * Revision 1.1.28.2  2006/07/31 13:36:27  endert
 * Added Java-Doc to constructors if missing, minor refactorings.
 * Revision 1.1.28.1 2006/07/26 15:28:28 endert
 * Formatted Code Revision 1.1 2006/03/13 07:37:50 axle moved from ROOT/src for
 * Maven 2 Buildsystem and Team/Soccerscope separation
 * 
 * Revision 1.8 2006/03/07 12:46:35 endert Merge after refactoring: - New
 * State-Interface: One Method for each action type - Action Bean removed -
 * ActionFactorys for helper methods, States calculate main-Action themselves -
 * formatted code - added State-List in Monitor (Context-Menu of Player) - other
 * smaller stuff
 * 
 * Revision 1.7.2.2 2006/03/06 23:17:51 endert Removed warnings, added
 * State-Overview to Context-Menu!
 * 
 * Revision 1.7.2.1 2006/02/25 22:07:33 wetzker formated
 * 
 * Revision 1.7 2006/02/22 16:04:48 endert This is done: - Rebound SoccerScope
 * to Agents (can be added or removed in config-file) - Situations now all
 * extend abstract class Situation - Refactorings: ActionBean _ removed from
 * Attributes - SoccerScope will automatically connect to host given in
 * Start-Call - Trainer uses the same host as soccerscope - Removed unused stuff
 * (old confs, bat, etc.) - Code formatted (good luck when merging) - organized
 * imports - all that i forgot to mention here Revision 1.6 2005/06/15 18:17:51
 * haeder removed unused imports
 * 
 * Revision 1.5 2005/06/15 17:03:17 wetzker removed JIAC from Head + changes in
 * framework please report bugs or shortcomings some scenarios might not work
 * because of wrong imports
 * 
 * Revision 1.2.2.1 2005/06/15 16:44:59 wetzker final version
 * 
 * Revision 1.4 2005/06/12 18:52:16 thyrion fixed saving&loading of our
 * worldmodel (to load first open server log)
 * 
 * Revision 1.3 2005/06/06 23:36:27 andpaul *** empty log message ***
 * 
 * Revision 1.2 2005/06/05 08:46:33 andpaul changed to jfreechart 1 pre 2
 * 
 * Revision 1.1 2005/04/20 10:39:06 endert Fresh Team Repository installation
 * from /home/e/endert/Robocup to here.
 * 
 * Revision 1.5 2005/03/20 21:39:36 andpaul removed some warnings
 * 
 * 
 * 
 * 
 * 
 */
