/*LICENSE_BEGIN
 * ******************************************************************
 * All original parts of SoccerScope2003 have copyright (2003) by
 * Team YowAI, represented by Mr. Shuhei Shiota
 * The Department of Creative Informatics
 * The Graduate School of Information Science and Technology
 * The University of Tokyo
 * 
 * Additional classes (except libraries in /lib) were developed by 
 * the Dainamite Robocup-Team of the DAI-Labor, TU-Berlin 
 * (www.dai-labor.de)
 * 
 * Extended/new classes/packages are:
 *   soccerscope.analyzer.LogfileAnalyzer
 *   soccerscope.daistatistic.*
 *   soccerscope.daistatistic.charts.*
 *   soccerscope.daistatistic.tools.*
 *   soccerscope.db.*
 *   soccerscope.dialog.*
 *   soccerscope.model.PlayerWorldModel
 *   soccerscope.model.SimplePlayer
 *   soccerscope.net.AgentConnector
 *   soccerscope.training.*
 *   soccerscope.training.conditions.*
 * ******************************************************************
LICENSE_END*/
package soccerscope.view.layer;

import java.awt.Dimension;
import java.awt.Graphics;

import soccerscope.util.Color2;
import soccerscope.view.FieldPane;

// åեΤ褹쥤䡼

public class PitchLayer extends Layer {

	public PitchLayer(FieldPane fieldPane) {
		super(fieldPane, true);
	}

	@Override
	public String getLayerName() {
		return "Pitch";
	}

	@Override
	public void draw(Graphics g) {
		Dimension d = this.fieldPane.getSize();
		g.setColor(Color2.indianRed);
		g.fillRect(0, 0, d.width, d.height);
		g.setColor(Color2.forestGreen);
		fillRect(g, topLeftCorner, pitchSize);
	}
}
